<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
<head>
	<title>CarbonPHP Documentation</title>
	<style type="text/css">
		* {
			margin: 0;
			padding: 0;
		}

		a, a:hover {
			background: transparent;
			border-bottom: 1px dotted #666;
			color: #666;
			text-decoration: none;		
		}

		a:hover {
			border: 0;
		}

		html {
			font-family: "Lucida Sans Unicode", "Lucida Grande";
			font-size: 14px;
		}

		body {
			background: #fff;
			color: #666;
		}

		h1 {
			font-size: 15px;
			font-weight: bold;
			margin: 0 0 5px 0;
		}

		h2 {
			font-size: 13px;
			font-weight: bold;
			margin: 5px 0 5px 0;
		}

		ol, ul {
			margin: 10px 0 10px 0;
			list-style-position: inside;
		}

		p {
			margin: 5px 0 5px 0;
		}

		.content {
			border: 1px dotted #444;
			margin: 10px;
			padding: 10px;
			text-align: justify;
			width: 700px;
		}

		.example {
			border: 1px solid #ccc;
			background: #eee;
			margin: 10px;
			padding: 10px;
			text-align: left;
		}
	</style>
</head>

<body>
	<div class="content">
		<h1>Form Utility</h1>

		<p>The form utility file contains functions that assist in working with and creating forms.  You load the
		utility with the following piece of code.</p>

		<div class="example">
			$this->load->utility('form');
		</div>
	</div>

	<div class="content">
		<h1>form_open()</h1>

		<p>This function creates an opening form tag with a base URL built from your configuration preferences.  It
		will optionally let you add form attributes and hidden input fields.  The main benefit of using this function
		rather than hard coding your own HTML is that it permits your site to be more portable in the event you
		choose to change your URLs.</p>

		<div class="example">
			echo form_open('email/submit');
		</div>

		<p>The above example will create a form that looks like the following.</p>

		<div class="example">
			&lt;form method="post" action="http://www.your-domain.com/index.php/email/submit" /&gt;
		</div>

		<p>Attributes can be added by passing an associative array as the second parameter.</p>

		<div class="example">
			$attr = array('class' => 'someform', 'id' => 'email');<br />
			<br />
			echo form_open('email/submit', $attr);
		</div>

		<p>This code would create the following opening form tag.</p>

		<div class="example">
			&lt;form method="post" action="http://www.your-domain.com/index.php/email/submit"
				class="someform" id="email" /&gt;
		</div>

		<p>You can create hidden fields by passing an associative array as a the third parameter.</p>

		<div class="example">
			$hidden = array('username' => 'John', 'id' => '2');<br />
			<br />
			echo form_open('email/send', '', $hidden);
		</div>

		<p>The above example will create the following form.</p>

		<div class="example">
			&lt;form method="post" action="http:/www.your-domain.com/index.php/email/submit" /&gt;<br />
			&lt;input type="hidden" name="username" value="John" /&gt;<br />
			&lt;input type="hidden" name="id" value="2" /&gt;
		</div>
	</div>

	<div class="content">
		<h1>form_input()</h1>

		<p>This function lets you generate a standard text input field.  You can minimally pass the field name
		and a value in the first and second parameters.</p>

		<div class="example">
			echo form_input('username', 'john');
		</div>

		<p>You can pass an associative array containing any data you wish your form to contain.</p>

		<div class="example">
			$data = array(<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'name' => 'username',<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'id' => 'username',<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'value' => 'john',<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'maxlength' => '100',<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'size' => '50',<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'style' => 'width: 100px'<br />
			);<br />
			<br />
			echo form_input($data);
		</div>

		<p>If you would like your form to contain any additional data like JavaScript you can pass it as a string
		in the third parameter.</p>

		<div class="example">
			$js = 'onclick="somefunction();"';<br />
			<br />
			echo form_input('username', 'john', $js);
		</div>
	</div>

	<div class="content">
		<h1>form_password()</h1>

		<p>This function is identical to <b>form_input()</b> except that it sets it as a password type.</p>
	</div>

	<div class="content">
		<h1>form_upload()</h1>

		<p>This function is identical to <b>form_input()</b> except that it set it as a file type, allowing it to
		be used to upload files.</p>
	</div>

	<div class="content">
		<h1>form_textarea()</h1>

		<p>This function is identical to <b>form_input()</b> exception that it generates a 'textarea' type.  Instead
		if maxlength and size attributes in the above example, you will instead specify rows and cols.</p>
	</div>

	<div class="content">
		<h1>form_dropdown()</h1>

		<p>This function lets you create a standard dropdown field.  The first parameter will contain the name of
		the field, the second parameter is an associative array of options and the third parameter will contain
		the value you wish to be selected by default.</p>

		<div class="example">
			$options = array(<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'small' => 'Small shirt',<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'medium' => 'Medium shirt',<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'large' => 'Large shirt',<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'xlarge' => 'Extra large shirt'<br />
			);<br />
			<br />
			echo form_dropdown('shirts', $options, 'large');
		</div>

		<p>If you wish to add any additional data like JavaScript you can pass it as a string in the fourth
		parameter.</p>

		<div class="example">
			$js = 'onchange="somefunction();"';<br />
			<br />
			echo form_dropdown('shirts', $options, 'large', $js);
		</div>
	</div>

	<div class="content">
		<h1>form_fieldset()</h1>
		
		<p>This function lets you generate a fieldset/legend field.</p>

		<div class="example">
			echo form_fieldset('Address Information');<br />
			echo "fieldset content here\n";<br />
			echo form_fieldset_close();<br />
			<br />
			// Produces<br />
			&lt;fieldset id="address_info"&gt;<br />
			&lt;legend>Address Information&lt;/legend&gt;<br />
			form content here<br />
			&lt;/fieldset&gt;
		</div>

		<p>Similar to the other functions, you can submit an associative array in the second parameter
		if you prefer to set addtional attributes.</p>

		<div class="example">
			$attributes = array('id' => 'address_info', 'class' => 'address_info');<br />
			echo form_fieldset('Address Information', $attributes);<br />
			echo "&lt;p&gt;fieldset content here&lt;/p&gt;\n";<br />
			echo form_fieldset_close();<br />
			<br />
			// Produces<br />
			&lt;fieldset id="address_info" class="address_info"&gt;<br />
			&lt;legend&gt;Address Information&lt;/legend&gt;<br />
			&lt;p&gt;form content here&lt;/p&gt;<br />
			&lt;/fieldset&gt;
		</div>
	</div>

	<div class="content">
		<h1>form_fieldset_close()</h1>
		
		<p>Produces a closing &lt;fieldset&gt; tag.  The only advantage to using this function is it permits you to pass
		data to it which will be added below to the tag.</p>

		<div class="example">
			$string = "&lt;/div&gt;&lt;/div&gt;";<br />
			<br />
			echo fieldset_close($string);<br />
			<br />
			// Produces:<br />
			&lt;/fieldset&gt;<br />
			&lt;/div&gt;&lt;/div&gt;<br />
		</div>
	</div>

	<div class="content">
		<h1>form_checkbox()</h1>

		<p>This function lets you generate a checkbox field.</p>

		<div class="example">
			echo form_checkbox('email', 'accept', true);
		</div>

		<p>The third parameter contains a true or false to determine whether the checkbox should be checked or not.</p>

		<p>Similar to the other form functions, you can pass an array of attributes to the functions.</p>

		<div class="example">
			$data = array(<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'name' => 'email',<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'id' => 'email',<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'value' => 'accept',<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'checked' => true,<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'style' => 'width: 10px;'<br />
			);<br />
			<br />
			echo form_checkbox($data);
		</div>

		<p>Just like the other functions if you wish the tag to contain additional data like JavaScript, you
		pass it as a string in the fourth parameter.</p>

		<div class="example">
			$js = 'onclick="somefunction();"';<br />
			<br />
			echo form_checkbox('email', 'accept', true, $js);
		</div>
	</div>

	<div class="content">
		<h1>form_radio()</h1>

		<p>This function is identical to the <b>form_checkbox()</b> function except it creates a radio type field.</p>
	</div>

	<div class="content">
		<h1>form_submit()</h1>

		<p>This function lets you generate a standard submit button.</p>

		<div class="example">
			echo form_submit('submit', 'Submit');
		</div>

		<p>As the same as other functions you can submit an associative array in the first parameter if you prefer to
		set your own attributes, the third parameter lets your add extra data for your form like JavaScript.</p>
	</div>

	<div class="content">
		<h1>form_label()</h1>

		<p>This function lets you generate a &lt;label&gt;.</p>

		<div class="example">
			echo form_label('What is your Name', 'username');<br />
			<br />
			// Would produce:<br />
			&lt;label id="username"&gt;What is your Name&lt;/label&gt;
		</div>

		<p>Similar to the other functions you can submit an associative array in the third parameter.</p>

		<div class="example">
			$attributes = array(<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'class' => 'mycustomclass',<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'style' => 'color: #000;',<br />
			);<br />
			echo form_label('What is your Name', 'username', $attributes);<br />
			<br />
			// Produces:<br />
			&lt;label id="username" class="mycustomclass" style="color: #000;"&gt;What is your Name&lt;/label&gt;
		</div>
	</div>

	<div class="content">
		<h1>form_reset()</h1>

		<p>This function generates a standard reset button, it is similar to <b>form_submit()</b>.</p>
	</div>

	<div class="content">
		<h1>form_close()</h1>

		<p>This function produces a closing form tag.  The only advantage to using this function is it allows you to
		pass data to it which will be added below the tag.</p>

		<div class="example">
			$string = '&lt;/div&gt;';<br />
			<br />
			echo form_close($string);<br />
			<br />
			// This produces:<br />
			// &lt;/form&gt;<br />
			// &lt;/div&gt;
		</div>
	</div>

	<div class="content">
		<h1>form_prep()</h1>

		<p>This function allows you to safely use HTML and characters such as quotes within form elements without
		breaking out of the form.</p>

		<div class="example">
			$string = 'Here is a string containing "quoted" text.';<br />
			<br />
			&lt;input type="text" name="form" value="$string" /&gt;
		</div>

		<p>Since the string contains quoted text so it will cause the form to break.  The <b>form_prep()</b> function
		converts HTML so that it can be used safely.</p>

		<div class="example">
			&lt;input type="text" name="form" value="&lt;?php echo form_prep($string); ?&gt;" /&gt;
		</div>

		<p>If you use any of the form utlity functions the values will automatically be prepped for you.</p>
	</div>
</body>

</html>
